--- res/res_monitor.c.orig	2008-01-31 21:00:24.000000000 +0000
+++ res/res_monitor.c	2009-06-16 09:31:19.000000000 +0000
@@ -379,9 +379,15 @@
 		const char *absolute = *fname_base == '/' ? "" : "/";
 		char tmpstring[sizeof(chan->monitor->filename_base)] = "";
 
+		char *name = chan->monitor->filename_base;
+		int directory2 = strchr(name, '/') ? 1 : 0;
+		const char *absolute2 = *name == '/' ? "" : "/";
+		char tmpstring2[sizeof(chan->monitor->filename_base)] = "";
+
 		/* before continuing, see if we're trying to rename the file to itself... */
-		snprintf(tmpstring, sizeof(tmpstring), "%s%s%s", directory ? "" : ast_config_AST_MONITOR_DIR, absolute, fname_base);
-		if (!strcmp(tmpstring, chan->monitor->filename_base)) {
+		snprintf(tmpstring,  sizeof(tmpstring),  "%s%s%s", directory  ? "" : ast_config_AST_MONITOR_DIR, absolute,  fname_base);
+		snprintf(tmpstring2, sizeof(tmpstring2), "%s%s%s", directory2 ? "" : ast_config_AST_MONITOR_DIR, absolute2, name);
+		if (!strcmp(tmpstring, tmpstring2)) {
 			if (option_debug > 2)
 				ast_log(LOG_DEBUG, "No need to rename monitor filename to itself\n");
 			UNLOCK_IF_NEEDED(chan, need_lock);
